var _templateObject = _taggedTemplateLiteral(['\n  display: ', ';\n  width: ', ';\n  font-weight: ', ';\n  text-align: center;\n  white-space: nowrap;\n  vertical-align: middle;\n  user-select: none;\n  border: ', ' solid\n    transparent;\n\n  ', ';\n\n  /* Share hover and focus styles */\n  ', ';\n\n  &:focus,\n  &.focus {\n    outline: 0;\n    box-shadow: ', ';\n  }\n\n  &.disabled,\n  &:disabled {\n    opacity: ', ';\n    ', ';\n  }\n\n  /* Opinionated: add "hand" cursor to non-disabled .btn elements */\n  &:not(:disabled):not(.disabled) {\n    cursor: pointer;\n  }\n\n  ', ';\n\n  ', ';\n\n  ', ';\n\n  ', ';\n\n  ', ';\n'], ['\n  display: ', ';\n  width: ', ';\n  font-weight: ', ';\n  text-align: center;\n  white-space: nowrap;\n  vertical-align: middle;\n  user-select: none;\n  border: ', ' solid\n    transparent;\n\n  ', ';\n\n  /* Share hover and focus styles */\n  ', ';\n\n  &:focus,\n  &.focus {\n    outline: 0;\n    box-shadow: ', ';\n  }\n\n  &.disabled,\n  &:disabled {\n    opacity: ', ';\n    ', ';\n  }\n\n  /* Opinionated: add "hand" cursor to non-disabled .btn elements */\n  &:not(:disabled):not(.disabled) {\n    cursor: pointer;\n  }\n\n  ', ';\n\n  ', ';\n\n  ', ';\n\n  ', ';\n\n  ', ';\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n      font-weight: ', ';\n      color: ', ';\n      background-color: transparent;\n\n\n\n      ', ';\n\n      &:focus,\n      &.focus {\n        text-decoration: ', ';\n        border-color: transparent;\n        box-shadow: none;\n      }\n\n      &:disabled,\n      &.disabled {\n        color: text-decoration: ', ';\n      }\n    '], ['\n      font-weight: ', ';\n      color: ', ';\n      background-color: transparent;\n\n\n\n      ', ';\n\n      &:focus,\n      &.focus {\n        text-decoration: ', ';\n        border-color: transparent;\n        box-shadow: none;\n      }\n\n      &:disabled,\n      &.disabled {\n        color: text-decoration: ', ';\n      }\n    ']),
    _templateObject3 = _taggedTemplateLiteral(['\n        color: ', ';\n        text-decoration: ', ';\n        background-color: transparent;\n        border-color: transparent;\n      '], ['\n        color: ', ';\n        text-decoration: ', ';\n        background-color: transparent;\n        border-color: transparent;\n      ']),
    _templateObject4 = _taggedTemplateLiteral(['\n      background-image: none;\n      ', ';\n    '], ['\n      background-image: none;\n      ', ';\n    ']);

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

import styled, { css } from 'styled-components';
import PropTypes from 'prop-types';

import themeProp from '../utils/src/theme';

import { boxShadow } from '../utils/src/box-shadow';
import { hover, hoverFocus } from '../utils/src/hover';
import { transition } from '../utils/src/transition';

import { buttonVariant } from './utils/button-variant';
import { buttonSize } from './utils/button-size';
import { buttonOutlineVariant } from './utils/button-outline-variant';

import defaultTheme from './defaultTheme';

var btnSizes = {
  normal: {
    paddingY: 'btnPaddingY',
    paddingX: 'btnPaddingX',
    fontSize: 'fontSizeBase',
    lineHeight: 'btnLineHeight',
    borderRadius: 'btnBorderRadius'
  },
  large: {
    paddingY: 'btnPaddingYlg',
    paddingX: 'btnPaddingXlg',
    fontSize: 'fontSizeLg',
    lineHeight: 'btnLineHeightLg',
    borderRadius: 'btnBorderRadiusLg'
  },
  small: {
    paddingY: 'btnPaddingYsm',
    paddingX: 'btnPaddingXsm',
    fontSize: 'fontSizeSm',
    lineHeight: 'btnLineHeightSm',
    borderRadius: 'btnBorderRadiusSm'
  }
};

var Button = styled.button(_templateObject, function (_ref) {
  var block = _ref.block;
  return block ? 'block' : 'inline-block';
}, function (props) {
  return props.block && '100%';
}, themeProp('btnFontWeight'), themeProp('btnBorderWidth', defaultTheme.btnBorderWidth), transition(themeProp('btnTransition', defaultTheme.btnTransition)), hoverFocus('text-decoration: none;'), themeProp('btnFocusBoxShadow', defaultTheme.btnFocusBoxShadow), themeProp('btnDisabledOpacity', defaultTheme.btnDisabledOpacity), boxShadow('none'), function (_ref2) {
  var theme = _ref2.theme,
      color = _ref2.color;
  return color !== 'link' && buttonVariant(theme[color], theme[color], theme.enableShadows, theme.btnBoxShadow, theme.btnActiveBoxShadow);
}, function (_ref3) {
  var color = _ref3.color;
  return color === 'link' && css(_templateObject2, themeProp('fontWeightNormal', 'normal'), themeProp('linkColor', '#007bff'), hover(css(_templateObject3, themeProp('linkHoverColor', '#0056b3'), themeProp('linkHoverDecoration', 'underline'))), themeProp('linkHoverDecoration', 'underline'), themeProp('btnLinkDisabledColor', '#6c757d'));
}, function (_ref4) {
  var theme = _ref4.theme,
      outline = _ref4.outline,
      color = _ref4.color;
  return outline && buttonOutlineVariant(theme[color]);
}, function (_ref5) {
  var size = _ref5.size,
      theme = _ref5.theme;
  return buttonSize(theme[btnSizes[size].paddingY] || defaultTheme[btnSizes[size].paddingY], theme[btnSizes[size].paddingX] || defaultTheme[btnSizes[size].paddingX], theme[btnSizes[size].fontSize] || defaultTheme[btnSizes[size].fontSize], theme[btnSizes[size].lineHeight] || defaultTheme[btnSizes[size].lineHeight], theme.enableRounded && (theme[btnSizes[size].borderRadius] || defaultTheme[btnSizes[size].borderRadius]));
}, function (_ref6) {
  var active = _ref6.active;
  return active && css(_templateObject4, boxShadow(themeProp('btnFocusBoxShadow', defaultTheme.btnFocusBoxShadow)));
});

Button.Link = Button.withComponent('a');

Button.defaultProps = {
  active: false,
  block: false,
  color: 'primary',
  size: 'normal',
  outline: false
};

Button.propTypes = {
  active: PropTypes.bool,
  block: PropTypes.bool,
  color: PropTypes.string,
  size: PropTypes.string,
  outline: PropTypes.bool
};

export default Button;